#
# Conditional build:
%bcond_without	vim		# make vim syntax package

# build noarch packages only for 7.0 version
%if 0%{?_pld_builder:1} && "%{?php_suffix}" != "70"
%undefine	with_vim
%endif

%define		php_name	php%{?php_suffix}
%define		modname	xdebug
Summary:	%{modname} - provides functions for functions traces and profiling
Summary(pl.UTF-8):	%{modname} - funkcje do śledzenia i profilowania funkcji
Name:		%{php_name}-pecl-%{modname}
Version:	2.7.1
Release:	1
# The Xdebug License, version 1.01
# (Based on "The PHP License", version 3.0)
License:	PHP
Group:		Development/Languages/PHP
Source0:	https://xdebug.org/files/xdebug-%{version}.tgz
# Source0-md5:	8833252b258c22f73ca5ae1d51e668b6
Source1:	%{modname}.ini
Source2:	vim-xt-filetype.vim
URL:		https://xdebug.org/
BuildRequires:	%{php_name}-devel >= 4:7.0
BuildRequires:	libedit-devel
BuildRequires:	libtool
BuildRequires:	rpmbuild(macros) >= 1.650
%{?requires_zend_extension}
Provides:	php(%{modname}) = %{version}
Obsoletes:	php-pecl-xdebug < 2.2.4-1
Conflicts:	ZendOptimizer
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_vimdatadir		%{_datadir}/vim

%description
The Xdebug extension helps you debugging your script by providing a
lot of valuable debug information. The debug information that Xdebug
can provide includes the following:

- stack and function traces in error messages with:
 - full parameter display for user defined functions
 - function name, file name and line indications
 - support for member functions
- memory allocation
- protection for infinite recursions

Xdebug also provides:

- profiling information for PHP scripts
- code coverage analysis
- capabilities to debug your scripts interactively with a debug client

%description -l pl.UTF-8
Rozszerzenie Xdebug pomaga przy odpluskwianiu skryptu dostarczając
dużo wartościowych informacji. Informacje przydatne do śledzenia,
które może zapewnić Xdebug, obejmują:

- śledzenie stosu i funkcji w komunikatach błędów wraz z:
 - pełnym wyświetlaniem parametrów dla funkcji zdefiniowanych przez
   użytkownika
 - nazwami funkcji, nazwami plików i numerami linii
 - obsługą metod klas
- przydzielanie pamięci
- zabezpieczenie przed nieskończoną rekurencją

Xdebug dostarcza także:

- informacje do profilowania skryptów PHP
- analizę wywołań skryptu
- możliwość śledzenia skryptów interaktywnie przy pomocy klienta
  odpluskwiacza

%package -n vim-syntax-xdebug
Summary:	Vim syntax: Xdebug trace files
Group:		Applications/Editors/Vim
Requires:	php(%{modname}) = %{version}
Requires:	vim-rt >= 4:7.2.170
BuildArch:	noarch

%description -n vim-syntax-xdebug
This plugin provides syntax highlighting Xdebug trace files (context
or unified).

%prep
%setup -qc
mv %{modname}-%{version}*/* .
chmod +x debugclient/configure

%{__sed} -e 's#^;zend_extension.*#zend_extension=%{php_extensiondir}/%{modname}.so#' %{SOURCE1} > %{modname}.ini

install -d vim/{syntax,ftdetect}
mv contrib/xt.vim vim/syntax
cp -p %{SOURCE2} vim/ftdetect/xt.vim

%build
# libtool 2.2 build fix
if [ -f %{_aclocaldir}/ltsugar.m4 ]; then
	cat %{_aclocaldir}/ltsugar.m4 >> config.m4
	cat %{_aclocaldir}/ltsugar.m4 >> debugclient/aclocal.m4

	cat %{_aclocaldir}/ltversion.m4 >> config.m4
	cat %{_aclocaldir}/ltversion.m4 >> debugclient/aclocal.m4

	cat %{_aclocaldir}/lt~obsolete.m4 >> config.m4
	cat %{_aclocaldir}/lt~obsolete.m4 >> debugclient/aclocal.m4

	cat %{_aclocaldir}/ltoptions.m4 >> config.m4
	cat %{_aclocaldir}/ltoptions.m4 >> debugclient/aclocal.m4

	cat %{_aclocaldir}/libtool.m4 >> debugclient/aclocal.m4
fi
phpize
%configure
%{__make}
cd debugclient
%configure \
	--with-libedit
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{php_sysconfdir}/conf.d,%{php_extensiondir}}

install -p debugclient/debugclient $RPM_BUILD_ROOT%{_bindir}/%{modname}%{?php_suffix}-debugclient
install -p modules/%{modname}.so $RPM_BUILD_ROOT%{php_extensiondir}
cp -a %{modname}.ini $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d

%if %{with vim}
# vim syntax
install -d $RPM_BUILD_ROOT%{_vimdatadir}
cp -a vim/* $RPM_BUILD_ROOT%{_vimdatadir}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%php_webserver_restart

%postun
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%files
%defattr(644,root,root,755)
%doc README.rst CREDITS contrib
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/%{modname}.ini
%attr(755,root,root) %{php_extensiondir}/%{modname}.so
%attr(755,root,root) %{_bindir}/xdebug*-debugclient

%if %{with vim}
%files -n vim-syntax-xdebug
%defattr(644,root,root,755)
%{_vimdatadir}/ftdetect/xt.vim
%{_vimdatadir}/syntax/xt.vim
%endif
%changelog
* Mon Apr 08 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-pecl-xdebug.git;a=log;h=master

* Mon Apr 08 2019 Adam Gołębiowski <adamg@pld-linux.org> bf2f1d0
- updated to 2.7.1

* Mon Sep 24 2018 Elan Ruusamäe <glen@pld-linux.org> 3171ad8
- up to xdebug-2.7.0beta1 with PHP 7.3 support

* Mon Sep 24 2018 Elan Ruusamäe <glen@pld-linux.org> 3ea1035
- up to 2.6.1 [2018-08-01]

* Tue Dec 05 2017 Elan Ruusamäe <glen@pld-linux.org> 16fe691
- up to 2.6.0alpha with PHP 7.2 support

* Fri Oct 27 2017 Elan Ruusamäe <glen@pld-linux.org> 1230eaf
- up to 2.5.5; Need a PHP version >= 5.5.0 and < 7.2.0

* Thu Oct 13 2016 Elan Ruusamäe <glen@delfi.ee> aef143f
- up to 2.4.1, php 7.1.0 supported

* Tue Jul 05 2016 Elan Ruusamäe <glen@delfi.ee> be2e4d1
- update xdebug.ini

* Tue Jul 05 2016 Elan Ruusamäe <glen@delfi.ee> 18fda28
- up to 2.4.0; php 7 support

* Tue Sep 29 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> a44e813
- up to 2.3.3

* Tue Mar 31 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 2826597
- up to 2.3.2; supports PHP5.4+ only

* Wed Jul 09 2014 Elan Ruusamäe <glen@delfi.ee> 1d489f2
- update xdebug.ini with (more) complete list of options

* Mon Jul 07 2014 Elan Ruusamäe <glen@delfi.ee> bcd8bd1
- fix undefine bcond

* Tue Jun 24 2014 Elan Ruusamäe <glen@delfi.ee> 3dda0a0
- add vim-syntax-xdebug package for vim syntax for trace files

* Tue Jun 24 2014 Elan Ruusamäe <glen@delfi.ee> de02be7
- define xdebug.cli_color

* Tue Jun 24 2014 Elan Ruusamäe <glen@delfi.ee> f8eab62
- add link to all settings

* Tue Jun 24 2014 Elan Ruusamäe <glen@delfi.ee> fe451df
- correct desc, clarify license

* Tue Jun 24 2014 Elan Ruusamäe <glen@delfi.ee> 6842e38
- up to 2.2.5

* Fri May 16 2014 Elan Ruusamäe <glen@delfi.ee> b8ab7be
- obsolete old php name
- release 2 (by relup.sh)

* Sun Apr 27 2014 Elan Ruusamäe <glen@delfi.ee> 0d0d513
- up to 2.2.4

* Fri Apr 11 2014 Elan Ruusamäe <glen@delfi.ee> a858121
- set xdebug.max_nesting_level=250

